// Generated by CoffeeScript 1.2.1-pre
(function() {
  var Agent, AgentCallController, AgentCallLogController, AgentController, AgentDetailController, AgentStateLogController, AgentStatusLogController, Agents, Call, Queue, QueueController, initializeIsotope, isotopeRoot, p, queueToClass, searchToQuery, socket, statusOrStateToClass,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor; child.__super__ = parent.prototype; return child; },
    __slice = [].slice;

  p = function() {
    var _ref;
    return (_ref = window.console) != null ? typeof _ref.debug === "function" ? _ref.debug.apply(_ref, arguments) : void 0 : void 0;
  };

  socket = null;

  isotopeRoot = null;

  searchToQuery = function(raw) {
    var part, query, _i, _len, _ref;
    if (/^[,\s]*$/.test(raw)) {
      $('#agents').isotope({
        filter: '*'
      });
      return false;
    }
    query = [];
    _ref = raw.split(/\s*,\s*/g);
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      part = _ref[_i];
      part = part.replace(/'/, '');
      query.push(":contains('" + part + "')");
    }
    return query.join(", ");
  };

  statusOrStateToClass = function(prefix, str) {
    if (!str) return;
    return prefix + str.toLowerCase().replace(/\W+/g, "-").replace(/^-+|-+$/g, "");
  };

  queueToClass = function(queue) {
    if (!queue) return;
    return queue.toLowerCase().replace(/\W+/g, '_').replace(/^_+|_+$/g, "");
  };

  initializeIsotope = function(elt) {
    $('#sort-agents a').click(function(event) {
      var sorter;
      sorter = $(event.target).attr('href').replace(/^#/, "");
      p("Sort by " + sorter);
      elt.isotope({
        sortBy: sorter
      });
      return false;
    });
    return elt.isotope({
      itemSelector: '.agent',
      layoutMode: 'fitRows',
      getSortData: {
        username: function(e) {
          return e.find('.username').text();
        },
        extension: function(e) {
          return e.find('.extension').text();
        },
        status: function(e) {
          var ext, order, status;
          ext = e.find('.extension').text();
          status = e.find('.status').text();
          order = (function() {
            switch (status) {
              case 'Available':
                return 5;
              case 'Available (On Demand)':
                return 6;
              case 'On Break':
                return 7;
              case 'Logged Out':
                return 8;
              default:
                return 4;
            }
          })();
          return parseInt([order, ext].join(''), 10);
        },
        idle: function(e) {
          return parseInt(e.find('.lastStatusChange').text(), 10) * -1;
        }
      },
      sortBy: 'status'
    });
  };

  Serenade.Helpers.liStatus = function(klass, name, status) {
    var a;
    a = $('<a href="#"/>').text(name);
    if (status === name) a.addClass('active');
    p(a);
    return a.get(0);
  };

  AgentCallController = (function() {

    AgentCallController.name = 'AgentCallController';

    function AgentCallController() {}

    AgentCallController.prototype.calltap = function() {
      return socket.live('uuid_calltap', {
        uuid: this.model.id,
        agent: this.model.agent.id
      });
    };

    return AgentCallController;

  })();

  Serenade.controller('agentCall', AgentCallController);

  AgentStatusLogController = (function() {

    AgentStatusLogController.name = 'AgentStatusLogController';

    function AgentStatusLogController() {}

    return AgentStatusLogController;

  })();

  Serenade.controller('agentStatusLog', AgentStatusLogController);

  AgentStateLogController = (function() {

    AgentStateLogController.name = 'AgentStateLogController';

    function AgentStateLogController() {}

    return AgentStateLogController;

  })();

  Serenade.controller('agentStateLog', AgentStateLogController);

  AgentCallLogController = (function() {

    AgentCallLogController.name = 'AgentCallLogController';

    function AgentCallLogController() {}

    return AgentCallLogController;

  })();

  Serenade.controller('agentCallLog', AgentCallLogController);

  AgentController = (function() {

    AgentController.name = 'AgentController';

    function AgentController() {}

    AgentController.prototype.details = function() {
      var view,
        _this = this;
      view = $(Serenade.render('agentDetail', this.model));
      view.on('shown', function() {
        var stateClass, statusClass;
        statusClass = statusOrStateToClass('status-', _this.model.status);
        stateClass = statusOrStateToClass('state-', _this.model.state);
        return $("button." + statusClass + ", button." + stateClass, view).button('reset').button('toggle');
      });
      view.on('hidden', function() {
        return view.remove();
      });
      view.modal('show');
      $('.nav-tabs a:first', view).tab('show');
      $('a[href="#agentDetailStatusLog"]').on('shown', function() {
        return socket.live('agent_status_log', {
          agent: _this.model.id,
          success: function(logs) {
            return $('#agentDetailStatusLog').html(Serenade.render('agentStatusLog', {
              statuses: new Serenade.Collection(logs)
            }));
          }
        });
      });
      $('a[href="#agentDetailStateLog"]').on('shown', function() {
        return socket.live('agent_state_log', {
          agent: _this.model.id,
          success: function(logs) {
            return $('#agentDetailStateLog').html(Serenade.render('agentStateLog', {
              states: new Serenade.Collection(logs)
            }));
          }
        });
      });
      return $('a[href="#agentDetailCallLog"]').on('shown', function() {
        return socket.live('agent_call_log', {
          agent: _this.model.id,
          success: function(logs) {
            return $('#agentDetailCallLog').html(Serenade.render('agentCallLog', {
              calls: new Serenade.Collection(logs)
            }));
          }
        });
      });
    };

    return AgentController;

  })();

  Serenade.controller('agent', AgentController);

  AgentDetailController = (function() {

    AgentDetailController.name = 'AgentDetailController';

    function AgentDetailController() {}

    AgentDetailController.prototype.statusAvailable = function(event) {
      return this.submitStatus('Available', $(event.target));
    };

    AgentDetailController.prototype.statusAvailableOnDemand = function(event) {
      return this.submitStatus('Available (On Demand)', $(event.target));
    };

    AgentDetailController.prototype.statusOnBreak = function(event) {
      return this.submitStatus('On Break', $(event.target));
    };

    AgentDetailController.prototype.statusLoggedOut = function(event) {
      return this.submitStatus('Logged Out', $(event.target));
    };

    AgentDetailController.prototype.stateWaiting = function(event) {
      return this.submitState('Waiting', $(event.target));
    };

    AgentDetailController.prototype.stateIdle = function(event) {
      return this.submitState('Idle', $(event.target));
    };

    AgentDetailController.prototype.submitStatus = function(name, button) {
      button.button('loading');
      return socket.live('agent_status', {
        agent: this.model.id,
        status: name,
        success: function() {
          return button.button('reset').button('toggle');
        }
      });
    };

    AgentDetailController.prototype.submitState = function(name, button) {
      button.button('loading');
      return socket.live('agent_state', {
        agent: this.model.id,
        state: name,
        success: function() {
          return button.button('reset').button('toggle');
        }
      });
    };

    return AgentDetailController;

  })();

  Serenade.controller('agentDetail', AgentDetailController);

  QueueController = (function() {

    QueueController.name = 'QueueController';

    function QueueController() {}

    QueueController.prototype.showQueue = function(event) {
      var queue,
        _this = this;
      queue = $(event.target).text();
      return socket.live('queue_agents', {
        queue: queue,
        success: function(msg) {
          var id, tier, _i, _len;
          for (_i = 0, _len = msg.length; _i < _len; _i++) {
            tier = msg[_i];
            id = tier.agent.split("-")[0];
            new Agent({
              id: id,
              queue: tier.queue,
              state: tier.state
            });
          }
          return isotopeRoot.isotope({
            filter: "." + queueToClass(queue)
          });
        }
      });
    };

    return QueueController;

  })();

  Serenade.controller('queueList', QueueController);

  Call = (function(_super) {

    __extends(Call, _super);

    Call.name = 'Call';

    Call.property('display_cid');

    Call.property('created_epoch');

    Call.property('duration');

    Call.property('initializeRan');

    Call.belongsTo('agent', {
      as: (function() {
        return Agent;
      })
    });

    Call.property('createdTime', {
      get: (function() {
        return (new Date(this.created)).toLocaleString();
      }),
      dependsOn: ['created']
    });

    Call.property('created', {
      get: (function() {
        return this.created_epoch * 1000;
      }),
      dependsOn: ['created_epoch']
    });

    function Call(obj) {
      Call.__super__.constructor.apply(this, arguments);
      if (this.initializeRan == null) this.initialize.apply(this, arguments);
    }

    Call.prototype.initialize = function() {
      var _this = this;
      this.timer = setInterval((function() {
        return _this.duration = Rubyists.formatInterval(_this.created);
      }), 1000);
      this.bind('delete', (function() {
        return _this.onDelete.apply(_this, arguments);
      }));
      return this.initializeRan = true;
    };

    Call.prototype.onDelete = function() {
      var _ref;
      clearInterval(this.timer);
      return (_ref = this.agent) != null ? _ref.lastStatusChange = Date.now() : void 0;
    };

    return Call;

  })(Serenade.Model);

  Agents = new Serenade.Collection([]);

  window.Agents = Agents;

  Agent = (function(_super) {

    __extends(Agent, _super);

    Agent.name = 'Agent';

    Agent.property('extension');

    Agent.property('username');

    Agent.property('state');

    Agent.property('status');

    Agent.property('timeSinceStatusChange');

    Agent.property('lastStatusChange');

    Agent.property('queue');

    Agent.property('initializeRan');

    Agent.hasMany('calls', {
      as: (function() {
        return Call;
      })
    });

    Agent.property('statusClass', {
      get: (function() {
        return statusOrStateToClass('status-', this.status);
      }),
      dependsOn: ['status']
    });

    Agent.property('queueClass', {
      get: (function() {
        return queueToClass(this.queue);
      }),
      dependsOn: ['queue']
    });

    function Agent(obj) {
      Agent.__super__.constructor.apply(this, arguments);
      if (this.initializeRan == null) this.initialize.apply(this, arguments);
    }

    Agent.prototype.initialize = function() {
      var dom;
      p("Creating agent:", this.id, this);
      this.setupTimer();
      dom = this.setupDOM();
      this.setupBinds(dom);
      return this.initializeRan = true;
    };

    Agent.prototype.setupTimer = function() {
      var _this = this;
      this.lastStatusChange = Date.now();
      return this.timer = setInterval((function() {
        return _this.timeSinceStatusChange = Rubyists.formatInterval(_this.lastStatusChange);
      }), 1000);
    };

    Agent.prototype.setupDOM = function() {
      var tag;
      tag = $(Serenade.render('agent', this));
      tag.addClass(this.statusClass);
      $('#agents').isotope('insert', tag);
      return tag;
    };

    Agent.prototype.setupBinds = function(tag) {
      var _this = this;
      this.bind('change:status', function(value) {
        return _this.lastStatusChange = Date.now();
      });
      this.bind('change:state', function(value) {
        return _this.lastStatusChange = Date.now();
      });
      this.calls.bind('delete', function(value) {
        return _this.lastStatusChange = Date.now();
      });
      this.bind('change:queue', function(value) {
        return tag.addClass(value);
      });
      this.bind('change:lastStatusChange', function(value) {
        return isotopeRoot.isotope('updateSortData', tag);
      });
      return this.bind('change:statusClass', function(value) {
        var klass, _i, _len, _ref;
        _ref = tag.attr('class').split(' ');
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          klass = _ref[_i];
          if (/^status-/.test(klass)) tag.removeClass(klass);
        }
        return tag.addClass(value);
      });
    };

    Agent.prototype.updateCall = function(msg) {
      var call, id;
      id = msg.id;
      this.calls.forEach(function(call) {
        if (call.id === id) return call.set(msg);
      });
      call = new Call(msg, false);
      return this.calls.set(call.id, call);
    };

    return Agent;

  })(Serenade.Model);

  Queue = (function(_super) {

    __extends(Queue, _super);

    Queue.name = 'Queue';

    function Queue() {
      return Queue.__super__.constructor.apply(this, arguments);
    }

    Queue.property('name', {
      serialize: true
    });

    return Queue;

  })(Serenade.Model);

  $(function() {
    var server,
      _this = this;
    Serenade.useJQuery();
    isotopeRoot = $('#agents');
    initializeIsotope(isotopeRoot);
    $('#show-all-queues').on('click', function() {
      return isotopeRoot.isotope({
        filter: "*"
      });
    });
    $('.navbar-search').on('submit', function(event) {
      return false;
    });
    $('#search').on('input', function(event) {
      var term;
      term = searchToQuery($(event.target).val());
      isotopeRoot.isotope({
        filter: term
      });
      return false;
    });
    $('#search').on('keyup', function(event) {
      if (event.keyCode === 13) return event.preventDefault();
    });
    server = $('#server').text();
    socket = new Rubyists.Socket({
      server: server
    });
    return socket.onopen = function() {
      socket.tag('live', function() {
        return p.apply(null, ['live'].concat(__slice.call(arguments)));
      });
      socket.tag('live:Agent', function(msg) {
        var id;
        id = msg.body.id;
        if ((msg.body.state != null) || (msg.body.status != null)) {
          return Agents.forEach(function(agent) {
            if (agent.id === id) return agent.set(msg.body);
          });
        } else {
          return p("unknown agent message:", msg);
        }
      });
      socket.tag('live:Call:create', function(msg) {
        var agentId;
        agentId = msg.body.agentId;
        return Agents.forEach(function(agent) {
          if (agent.id === agentId) return agent.updateCall(msg.body);
        });
      });
      socket.tag('live:Call:update', function(msg) {
        var agentId;
        agentId = msg.body.agentId;
        return Agents.forEach(function(agent) {
          if (agent.id === agentId) return agent.updateCall(msg.body);
        });
      });
      socket.tag('live:Call:delete', function(msg) {
        var agent, agents, call, calls, ids, _i, _len, _results;
        agents = Agents.select(function(agent) {
          return (agent != null ? agent.id : void 0) === msg.body.agentId;
        });
        ids = [msg.body.id, msg.body.uuid, msg.body.call_uuid];
        _results = [];
        for (_i = 0, _len = agents.length; _i < _len; _i++) {
          agent = agents[_i];
          calls = agent.calls.select(function(call) {
            var any, id, _j, _len2;
            any = false;
            for (_j = 0, _len2 = ids.length; _j < _len2; _j++) {
              id = ids[_j];
              any = any || call.id === id;
            }
            return any;
          });
          _results.push((function() {
            var _j, _len2, _results2;
            _results2 = [];
            for (_j = 0, _len2 = calls.length; _j < _len2; _j++) {
              call = calls[_j];
              _results2.push(p('deleting', agent.calls["delete"](call)));
            }
            return _results2;
          })());
        }
        return _results;
      });
      return socket.live('subscribe', {
        name: $('#agent_name').text(),
        success: function() {
          var _this = this;
          socket.live('queues', {
            success: function(msg) {
              var queues;
              queues = new Serenade.Collection(msg.queues);
              return $('#queues').replaceWith(Serenade.render('queueList', {
                queues: queues
              }));
            }
          });
          return socket.live('agents', {
            success: function(msg) {
              var agentMsg, call, calls, _i, _j, _len, _len2, _ref, _results;
              _ref = msg.agents;
              _results = [];
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                agentMsg = _ref[_i];
                if (calls = agentMsg.calls) {
                  p(agentMsg.id, calls);
                  for (_j = 0, _len2 = calls.length; _j < _len2; _j++) {
                    call = calls[_j];
                    delete call.agentId;
                  }
                  agentMsg.calls = calls;
                }
                _results.push(Agents.push(new Agent(agentMsg)));
              }
              return _results;
            }
          });
        }
      });
    };
  });

}).call(this);
